#ifdef GL_ES
// define default precision for float, vec, mat.
precision lowp float;
precision lowp sampler2D;
#endif

varying vec4 outColor;
//varying vec4 outTColor;
varying vec2 outTexc;
varying vec4 outFogColor;

varying vec4 outSpecColor;

uniform vec4 tcolor0;
uniform vec4 tcolor1;
uniform sampler2D baseTex;
uniform sampler2D coatTex;
uniform sampler2D maskTex;

/*
lowp float linstep(in mediump float slopeStart, in mediump float slopeEnd, in mediump float value)
{
    float diff = slopeEnd - slopeStart;
    // this check can be skipped if we know that slopeStart != slopeEnd
    //if (diff == 0)
    //    return step(slopeStart, value);
    return clamp((value - slopeStart) / diff, 0.0, 1.0);
}
*/

void main()
{
	vec4 baseColor = texture2D(baseTex, outTexc) + tcolor0;
	vec4 coatColor = texture2D(coatTex, outTexc) + tcolor1;
    mediump float mask = texture2D(maskTex, outTexc).r;
    mediump float outColora = outColor.a;
    mediump float maskedColor  = outColora * mask;
    // coat alpha threshold is at 0.3
    //lowp float alpha = linstep(0.28, 0.32, maskedColor);
    float alpha = clamp((maskedColor - 0.28) * 25.0, 0.0, 1.0);
    float dimmer = 1.0 - alpha;
    vec4 texColor = mix(baseColor * dimmer, coatColor, alpha);

/*	mediump float specVal =mask;
	float specMask = 0.5 + clamp(specVal, 0.0, 0.5);
	vec4 specular = (outSpecColor * specVal * (0.5 + alpha*0.5));*/
	vec4 specular = outSpecColor;

	vec4 color = outColor * texColor + specular;

	gl_FragColor = vec4(mix(color.xyz, outFogColor.xyz, outFogColor.w), color.w);
}
