#ifdef GL_ES
// define default precision for float, vec, mat.
precision lowp float;
#endif

varying vec4 outColor;
varying vec4 outTColor; // texture format compensation color
varying vec4 outFogColor;

uniform sampler2D tex;

void main()
{
	vec4 color = outColor * (texture2D(tex, gl_PointCoord) + outTColor);
	if (color.w < 0.3) discard;
	gl_FragColor = vec4(color.xyz*(1.0-outFogColor.w) + outFogColor.xyz*outFogColor.w, color.w);
}
