uniform mat4 mv;
uniform mat4 mvp;
uniform vec4 tcolor;
uniform float vheight; // view wheight

attribute vec4 pos;
attribute vec4 color;
attribute float size;

uniform vec4 fogColor;
uniform vec2 fogRange;

varying vec4 outColor;
varying vec4 outTColor;
varying vec4 outFogColor;

void main()
{
	gl_Position = mvp * pos;
	gl_PointSize = (size*vheight) / gl_Position.w;

	vec4 wpos = mv * pos;
	outFogColor = vec4(fogColor.xyz, clamp((length(wpos)-fogRange.x)/fogRange.y,0.0,1.0));

	outColor = color;
	outTColor = tcolor;
}
